@Echo off

if exist C:\OEM\HOTFIX-TPM.txt del /q C:\OEM\HOTFIX-TPM.txt
devcon.exe hwids * >> C:\OEM\HOTFIX-TPM.txt
timeout /t 5

FIND /I "PNP0C31" C:\OEM\HOTFIX-TPM.txt
IF %ERRORLEVEL%==0 GOTO TPM


SET LogPath=C:\Windows\System32\OEM\preload.log
echo. >> %LogPath%
echo ------ Enter %~dpnx0 on %DATE% %TIME% ------ >> %LogPath%
SET HotfixKB=%1
SET Flag=CHECK
SET Count=0
SET OS=x86
SET OSType=%2
IF /I "%Processor_Architecture%" EQU "AMD64" SET OS=x64
pushd %~dp0

call :Reinstall_%OSType%

find /i "FLOW=CD2D_REHDD" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is CD2D_REHDD Flow, No Need Installation Detect >> %LogPath%
	SET Flag=NoCHECK
)
find /i "FLOW=CD2D" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is CD2D Flow, No Need Installation Detect >> %LogPath%
	SET Flag=NoCHECK
)
find /i "FLOW=D2D" C:\OEM\Preload\Command\AlaunchX\NAPP.ini >> %LogPath% 2>&1
if %errorlevel% EQU 0 (
	echo errorlevel = %errorlevel%, This is D2D Flow, No Need Installation Detect >> %LogPath%
	SET Flag=NoCHECK
)
if %Flag% EQU CHECK (
	echo Flag = %Flag%, Not D2D or CD2D Flow, Do Installation Detect >> %LogPath%
	call :Check
)

popd
echo ------ Leave %~dpnx0 on %DATE% %TIME% ------ >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
exit /b 0


:Reinstall_W7
ECHO.>>%LogPath%
ECHO [Install] Windows6.1-%HotfixKB%-v7-%OS%.MSU /quiet /norestart >> %LogPath% 2>&1
Windows6.1-%HotfixKB%-v7-%OS%.MSU /quiet /norestart >> %LogPath% 2>&1
timeout /t 10 /nobreak
FOR /F "DELIMS=" %%H in ('DIR /b IE1?-Windows6.1-%HotfixKB%-v7-%OS%.MSU') do (
	ECHO [Install] %%H /quiet /norestart >> %LogPath% 2>&1
	%%H /quiet /norestart >> %LogPath% 2>&1
	timeout /t 10 /nobreak
)
exit /b 0



:Reinstall_W81
ECHO.>>%LogPath%
ECHO [Install] Windows8.1-%HotfixKB%-v2-%OS%.MSU /quiet /norestart>> %LogPath%
Windows8.1-%HotfixKB%-v2-%OS%.MSU /quiet /norestart >> %LogPath% 2>&1
timeout /t 10 /nobreak
exit /b 0



:Check
ECHO [Check] Do Hotfix Check>> %LogPath%
IF %Count% GEQ 3 call :ERROR && exit /b 0
Set /A Count+=1
Echo [Check] Install at %Count%th times, DISM /online /Get-Packages >> %LogPath%
DISM /online /Get-Packages > C:\OEM\preload\HotfixList.log
FIND /I "%HotfixKB%" C:\OEM\preload\HotfixList.log >> %LogPath% 2>&1
IF "%ERRORLEVEL%" NEQ "0" (
	ECHO [Check] Install %HotfixKB% fail, install and check again >>%LogPath%
	ECHO.>>%LogPath%
	call :Reinstall_%OSType%
	goto Check
)
exit /b 0

:TPM
exit /b 0

:ERROR
echo. >> %LogPath%
echo. >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo [ERROR] [ERROR] [ERROR] Total try to Reinstall %APName% %Count% times failed >> %LogPath%
echo. >> %LogPath%
echo. >> %LogPath%
shutdown /r /t 5
pause
exit /b 0